/*
Module : GETFLDER.H
Purpose: Defines the interface to a for a MFC DDX_ routine to get a directory/folder
         Using the file open/save as common dialogs
Created: PJN / DDXGETFOLDER/1 / 26-03-1997
History: None

Copyright (c) 1997 by PJ Naughter.  
All rights reserved.

*/


////////////////////////////////// Macros ///////////////////////////

#ifndef __GETFLDER_H__
#define __GETFLDER_H__


////////////////////////////////// Consts /////////////////////////////////////

//flags used to control how the DDX_GetFolderControl routine workds

const DWORD GFLDR_OLD_STYLE_DIALOG = 0x0001;   //Use the old style file open dialog instead of the
                                               //style as used in Windows Explorer



////////////////////// foward declaration ///////////////////////////
class CGetFolderControl;


/////////////////////////// Classes /////////////////////////////////
class CModifyButtonForFolder : public CButton
{
public:
  CModifyButtonForFolder();
  void SetBuddy(CGetFolderControl* pBuddy);

protected:
  //{{AFX_VIRTUAL(CModifyButtonForFolder)
	public:
  virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

  //{{AFX_MSG(CModifyButtonForFolder)
  afx_msg void OnClicked();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
#if ADD_ON_DESTROY
  afx_msg void OnDestroy();
#endif

  DECLARE_MESSAGE_MAP()

  CGetFolderControl* m_pBuddy;
  CToolTipCtrl m_ToolTip;
};



class CGetFolderControl : public CStatic
{
public:
  CGetFolderControl();

  BOOL SubclassEdit(HWND hEdit);
  void SetFlags(DWORD dwFlags, const CString& sTitle);
  void Edit();

protected:
  //{{AFX_VIRTUAL(CGetFolderControl)
  //}}AFX_VIRTUAL

  //{{AFX_MSG(CGetFolderControl)
	afx_msg void OnEnable(BOOL bEnable);
	//}}AFX_MSG

  DECLARE_MESSAGE_MAP()

  BOOL AddEditButton();
  static int CALLBACK SetSelProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);

  CModifyButtonForFolder m_Edit;
  DWORD         m_dwFlags;
  CString       m_sTitle;
  CString       m_sExtFilter;
};





/////////////// MFC Data exchange routines //////////////////////////

void DDX_GetFolderControl(CDataExchange* pDX, int nIDC, CGetFolderControl& rCGetFolderControl, DWORD dwFlags, const CString& sTitle);


#endif //__GETFLDER_H__